package org.processmining.timebasedabstraction.algorithms;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import weka.core.Instances;
import weka.filters.Filter;
import weka.filters.unsupervised.instance.RemovePercentage;

public class ElbowMethod {

	public int threadCount = Runtime.getRuntime().availableProcessors() - 2;
	public int stop = 20;
	public Map<Thread, Runnable> map = new HashMap<Thread, Runnable>();
	RemovePercentage rp = new RemovePercentage();
	private Instances reducedData;
	
	public double[] run(Instances data) throws Exception {
		data.randomize(new Random());
		rp.setPercentage(50);
		rp.setInputFormat(data);
		reducedData = Filter.useFilter(data, rp);
		
		System.out.println("Spawning Threads...");

		ArrayList<Thread> threads = new ArrayList<Thread>();
		int incrementAmount = stop / threadCount;
		int remainder = stop % threadCount;
		int starting = 1;

		for (int i = 0; i < threadCount; i++) {
			if (i >= threadCount - remainder) {
				ElbowMethodRunnable runnablei = new ElbowMethodRunnable(reducedData, starting, starting + incrementAmount + 1);
				Thread thread = new Thread(runnablei);
				map.put(thread, runnablei);
				threads.add(thread);
				starting += incrementAmount + 1;
			} else {
				ElbowMethodRunnable runnablei = new ElbowMethodRunnable(reducedData, starting, starting + incrementAmount);
				Thread thread = new Thread(runnablei);
				map.put(thread, runnablei);
				threads.add(thread);
				starting += incrementAmount;
			}			
		}

		for (int i = 0; i < threads.size(); i++) {
			threads.get(i).start();
		}

		for (int i = 0; i < threads.size(); i++) {
			try {
				threads.get(i).join();
				System.out.println("Thread" + i + " finished!");
			} catch (InterruptedException ex) {				
			}
		}

		ArrayList<Double> errs = new ArrayList<Double>();
		for (Thread thread : threads) {
			ElbowMethodRunnable runnable = (ElbowMethodRunnable) map.get(thread);		
			for (double err : runnable.getErrorList()) {
				errs.add(err);
			}
//			errs.addAll(runnable.getErrorList());
		}

		double[] sqErrorArray = new double[20];
		for (int i = 0; i < sqErrorArray.length; i++) {
			sqErrorArray[i] = errs.get(i);
		}
		return sqErrorArray;

	}

//		SimpleKMeans kmeans = new SimpleKMeans();
//		RemovePercentage rp = new RemovePercentage();
//		Random random = new Random();
//		private double[] sqErrArray;
//		private double avg;
//		private double sum;
//		private int counter;
//		private Instances reducedData;
//	
//		public double[] run(Instances data) throws Exception {	
//			data.randomize(new Random());
//			rp.setPercentage(50);
//			rp.setInputFormat(data);
//			reducedData = Filter.useFilter(data, rp);
//	
//			sqErrArray = new double[20];
//			for (int i = 1; i <= 20; i++) {
//				kmeans.setNumClusters(i);
//	
//				avg = 0.0d;
//				sum = 0.0d;
//				counter = 0;
//				for (int j = 1; j <= 3; j++) {
//					kmeans.setSeed(random.nextInt() * j);
//					kmeans.buildClusterer(reducedData);
//					sum += kmeans.getSquaredError();	
//					counter++;
//				}
//				avg = sum / counter;	
//				sqErrArray[i - 1] = avg;
//			}
//	
//			return sqErrArray;
//		}
}
