package org.processmining.timebasedabstraction.algorithms;

import java.util.ArrayList;

import weka.clusterers.SimpleKMeans;
import weka.core.Instances;
import weka.filters.unsupervised.instance.RemovePercentage;

public class ElbowMethodRunnable implements Runnable {

	SimpleKMeans kmeans = new SimpleKMeans();
	RemovePercentage rp = new RemovePercentage();
	ArrayList<Double> sqErrorList = new ArrayList<Double>();
	private Instances thisData;

	int start;
	int stop;
	boolean lead = false;

	public ElbowMethodRunnable(Instances data, int startValue, int stopValue) {
		this.thisData = data;
		this.start = startValue;
		this.stop = stopValue;
	}

	@Override
	public void run() {
		try {
			for (int i = start; i < stop; i++) {
				kmeans.setNumClusters(i);
				kmeans.setSeed(42);
				kmeans.buildClusterer(thisData);
				sqErrorList.add(kmeans.getSquaredError());	
			}
		} catch (Exception e) {			
		}
	}

	public ArrayList<Double> getErrorList() {
		return sqErrorList;
	}

}
