package org.processmining.timebasedabstraction.dialogs;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JPanel;
import javax.swing.Timer;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.deckfour.xes.model.XLog;
import org.processmining.timebasedabstraction.parameters.Parameters;

import com.fluxicon.slickerbox.factory.SlickerDecorator;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class Dialog extends JPanel {

	// Variables declaration - do not modify                     
	private javax.swing.ButtonGroup buttonGroup;
	private javax.swing.JComboBox<String> jComboBox1;
	private javax.swing.JRadioButton option1;
	private javax.swing.JRadioButton option2;
	private javax.swing.JRadioButton option3;
	private javax.swing.JRadioButton option4;
	private javax.swing.JRadioButton option5;
	private javax.swing.JTextField textField;
	private javax.swing.JLabel label1;
	private javax.swing.JButton button;

	private String item;
	// End of variables declaration              

	private static final long serialVersionUID = 1L;

	public Dialog(XLog log, final Parameters parameters) {
		label1 = SlickerFactory.instance().createLabel("<html><h2>Select Mining Parameters</h2>");
		button = SlickerFactory.instance().createButton("Set Parameters");

		buttonGroup = new javax.swing.ButtonGroup();
		option1 = new javax.swing.JRadioButton();
		SlickerDecorator.instance().decorate(option1);
		option2 = new javax.swing.JRadioButton();
		SlickerDecorator.instance().decorate(option2);
		option3 = new javax.swing.JRadioButton();
		SlickerDecorator.instance().decorate(option3);
		option4 = new javax.swing.JRadioButton();
		SlickerDecorator.instance().decorate(option4);
		option5 = new javax.swing.JRadioButton();
		SlickerDecorator.instance().decorate(option5);
		textField = new javax.swing.JTextField(10);
		jComboBox1 = new javax.swing.JComboBox<>();
		SlickerDecorator.instance().decorate(jComboBox1);

		option1.setText("15 Minutes Interval");
		option2.setText("Daily Interval");
		option3.setText("Weekly Interval");
		option4.setText("Monthly Interval");
		option5.setText("Set Your Own Time Interval");
		option5.setFont(new Font("Sans Serif", Font.ITALIC, 12));
		textField.setVisible(false);
		jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Minutes", "Hours", "Days", "Weeks", "Months"}));
		jComboBox1.setVisible(false);
		button.setVisible(false);

		buttonGroup.add(option1);
		buttonGroup.add(option2);
		buttonGroup.add(option3);
		buttonGroup.add(option4);
		buttonGroup.add(option5);

		option5.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				if (option5.isSelected()) {
					textField.setVisible(true);
					jComboBox1.setVisible(true);
					button.setVisible(true);
					revalidate();
					repaint();
					System.out.println("Option5 is selected!!");
					System.out.println((String) jComboBox1.getSelectedItem());

					item = (String) jComboBox1.getSelectedItem();
					parameters.setComboBoxItem(item);
					System.out.println(item);

					if (item.equals("Minutes")) {
						parameters.setMineMode(parameters.MINUTES);
					} else if (item.equals("Hours")) {
						parameters.setMineMode(parameters.HOURS);
					} else if (item.equals("Days")) {
						parameters.setMineMode(parameters.DAYS);
					} else if (item.equals("Weeks")) {
						parameters.setMineMode(parameters.WEEKS);
					} else if (item.equals("Months")) {
						parameters.setMineMode(parameters.MONTHS);
					}

				} else {
					textField.setVisible(false);
					jComboBox1.setVisible(false);
					button.setVisible(false);
					revalidate();
					repaint();
				}
			}			
		});

		textField.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {				
			}
			public void keyReleased(KeyEvent arg0) {				
			}
			public void keyTyped(KeyEvent e) {
				char c = e.getKeyChar();
				if (!(Character.isDigit(c) || (c == KeyEvent.VK_BACK_SPACE) || c == KeyEvent.VK_DELETE)) {
					getToolkit().beep();
					e.consume();
				}
			}			
		});

		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e ) {
				if (!textField.getText().isEmpty()) {
					String number = textField.getText();
					int num = Integer.parseInt(number);
					parameters.setTextFieldValue(num);
					System.out.println(num);
				}
				
				item = (String) jComboBox1.getSelectedItem();
				parameters.setComboBoxItem(item);
				System.out.println(item);

				if (item.equals("Minutes")) {
					parameters.setMineMode(parameters.MINUTES);
				} else if (item.equals("Hours")) {
					parameters.setMineMode(parameters.HOURS);
				} else if (item.equals("Days")) {
					parameters.setMineMode(parameters.DAYS);
				}
				
				button.setText("Parameters Set!");
				Timer timer = new Timer(2000, new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						button.setText("Set Parameters");
					}
				});
				timer.start();
				
			}
		});

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(label1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        	.addComponent(option5)
                            .addComponent(option4)
                            .addComponent(option3)
                            .addComponent(option2)
                            .addComponent(option1)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(textField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(0, 547, Short.MAX_VALUE))))
            .addGroup(layout.createSequentialGroup()
                .addGap(50, 50, 50)
                .addComponent(button)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(option1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(option2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(option3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(option4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(option5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(button)
                .addContainerGap(154, Short.MAX_VALUE))
        );

	}


}
