package org.processmining.timebasedabstraction.plugins;

import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.deckfour.xes.model.XLog;
import org.processmining.timebasedabstraction.export.ExportDays;
import org.processmining.timebasedabstraction.export.ExportHours;
import org.processmining.timebasedabstraction.export.ExportMinutes;
import org.processmining.timebasedabstraction.export.ExportMonths;
import org.processmining.timebasedabstraction.export.ExportWeeks;
import org.processmining.timebasedabstraction.models.TimeAndCountModel;

public class CreateAbstractedLog {

	private boolean withNumbers;
	/********************Create Abstract Logs Time & Count*********************/
	// Default
	public XLog mineAbstractLogMinutes(XLog log, TimeAndCountModel model) {
		ExportMinutes exportMinutes = new ExportMinutes();
		return exportMinutes.mineAbstractLogMinutes(log, model, withNumbers);
	}
	
	public XLog mineAbstractLogHours(XLog log, TimeAndCountModel model) {
		ExportHours exportHours = new ExportHours();
		return exportHours.mineAbstractLogHours(log, model, withNumbers);
	}
	
	public XLog mineAbstractLogDays(XLog log, TimeAndCountModel model) {
		ExportDays exportDays = new ExportDays();
		return exportDays.mineAbstractLogDays(log, model, withNumbers);
	}
	
	public XLog mineAbstractLogWeeks(XLog log, TimeAndCountModel model) {
		ExportWeeks exportWeeks = new ExportWeeks();
		return exportWeeks.mineAbstractLogWeeks(log, model, withNumbers);
	}
	
	public XLog mineAbstractLogMonths(XLog log, TimeAndCountModel model) {
		ExportMonths exportMonths = new ExportMonths();
		return exportMonths.mineAbstractLogMonths(log, model, withNumbers);
	}

	/************************************************************************/

	public static Object getKeyFromValue(Map hm, Object value) {
		for (Object o : hm.keySet()) {
			if (hm.get(o).equals(value)) {
				return o;
			}
		}
		return null;
	}

	public boolean stringContainsNumber(String s) {
		return Pattern.compile("[0-9]").matcher(s).find();
	}

	public String incrementOne(String s) {
		Pattern digitPattern = Pattern.compile("(\\d+)");
		Matcher matcher = digitPattern.matcher(s);
		StringBuffer result = new StringBuffer();
		while(matcher.find()) {
			matcher.appendReplacement(result, String.valueOf(Integer.parseInt(matcher.group(1)) + 1));
		}
		matcher.appendTail(result);
		return result.toString();
	}

	public void setWithNumbers(boolean checked) {
		this.withNumbers = checked;		
	}

	public Boolean getWithNumbers() {
		return withNumbers;
	}

}
