package org.processmining.timebasedabstraction.visualization;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JDialog;
import javax.swing.JRootPane;
import javax.swing.border.BevelBorder;

import org.jfree.chart.ChartPanel;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/*
 * To show the chart when you click on a button
 */
public class ChartDialog extends JDialog implements WindowListener {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	
	private int posX, posY;
	
	public ChartDialog(ChartPanel panel) {
		setSize(600, 400);
		getRootPane().setWindowDecorationStyle(JRootPane.NONE);
		
		SlickerFactory factory = SlickerFactory.instance();
		
		panel.setBorder(new BevelBorder(BevelBorder.RAISED, null, null, null, null));
		panel.setBounds(0, 0, 350, 150);
		panel.setLayout(null);
		
		getContentPane().add(panel);
	}
	
	private void enableDragging(Component component) {
		component.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				posX = e.getX();
				posY = e.getY();
			}
		});
		
		component.addMouseMotionListener(new MouseAdapter() {
			public void mouseDragged(MouseEvent evt) {
				// Sets frame position when mouse dragged
				Rectangle rectangle = getBounds();
				ChartDialog.this.setBounds(evt.getXOnScreen() - posX, evt.getYOnScreen() - posY,
						rectangle.width, rectangle.height);
			}
		});
	}
	
	
	public void windowActivated(WindowEvent arg0) {
	}

	public void windowClosed(WindowEvent arg0) {
	}

	public void windowClosing(WindowEvent arg0) {
	}

	public void windowDeactivated(WindowEvent arg0) {
		toFront();		
	}

	public void windowDeiconified(WindowEvent e) {
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowOpened(WindowEvent e) {		
	}
}
