//package org.processmining.timebasedabstraction.visualization;
//
//import java.awt.BasicStroke;
//import java.awt.BorderLayout;
//import java.awt.Color;
//import java.awt.Container;
//import java.awt.Dimension;
//import java.awt.GridLayout;
//import java.awt.MouseInfo;
//import java.awt.event.ActionEvent;
//import java.awt.event.ActionListener;
//import java.awt.event.ItemEvent;
//import java.awt.event.ItemListener;
//import java.lang.reflect.Field;
//import java.util.ArrayList;
//import java.util.Collection;
//import java.util.Collections;
//import java.util.List;
//import java.util.Map;
//import java.util.Map.Entry;
//import java.util.TreeMap;
//import java.util.concurrent.Executor;
//
//import javax.swing.Box;
//import javax.swing.BoxLayout;
//import javax.swing.DefaultComboBoxModel;
//import javax.swing.ImageIcon;
//import javax.swing.JButton;
//import javax.swing.JCheckBox;
//import javax.swing.JComboBox;
//import javax.swing.JComponent;
//import javax.swing.JLabel;
//import javax.swing.JPanel;
//import javax.swing.JScrollPane;
//import javax.swing.JSplitPane;
//import javax.swing.JTabbedPane;
//import javax.swing.JTextField;
//import javax.swing.Timer;
//import javax.swing.border.EmptyBorder;
//
//import org.deckfour.uitopia.api.model.ResourceType;
//import org.deckfour.xes.model.XLog;
//import org.jfree.chart.ChartFactory;
//import org.jfree.chart.ChartPanel;
//import org.jfree.chart.JFreeChart;
//import org.jfree.chart.plot.PlotOrientation;
//import org.jfree.chart.plot.XYPlot;
//import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
//import org.jfree.data.xy.XYDataset;
//import org.jfree.data.xy.XYSeries;
//import org.jfree.data.xy.XYSeriesCollection;
//import org.processmining.contexts.uitopia.UIContext;
//import org.processmining.contexts.uitopia.UIPluginContext;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.contexts.uitopia.annotations.Visualizer;
//import org.processmining.contexts.uitopia.model.ProMPOResource;
//import org.processmining.contexts.uitopia.model.ProMTask;
//import org.processmining.framework.plugin.GlobalContext;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.providedobjects.ProvidedObjectID;
//import org.processmining.plugins.utils.ProvidedObjectHelper;
//import org.processmining.timebasedabstraction.algorithms.Dbscan;
//import org.processmining.timebasedabstraction.algorithms.ElbowMethod;
//import org.processmining.timebasedabstraction.algorithms.KMeans;
//import org.processmining.timebasedabstraction.models.TimeAndCountModel;
//import org.processmining.timebasedabstraction.parameters.Parameters;
//import org.processmining.timebasedabstraction.plugins.CreateAbstractedLog;
//import org.processmining.timebasedabstraction.plugins.TimeAndCountPlugin3;
//import org.tc33.jheatchart.HeatChart;
//
//import com.fluxicon.slickerbox.components.NiceDoubleSlider;
//import com.fluxicon.slickerbox.components.NiceIntegerSlider;
//import com.fluxicon.slickerbox.components.NiceSlider.Orientation;
//import com.fluxicon.slickerbox.factory.SlickerDecorator;
//import com.fluxicon.slickerbox.factory.SlickerFactory;
//
//public class SessionsVisualizer6 {
//
//	UIPluginContext globalContext;
//	TimeAndCountModel globalModel;
//	Parameters globalParameter;
//
//	private SlickerFactory slickerFactory;
//	private SlickerDecorator slickerDecorator;
//
//	private JPanel headPanel;
//	private JPanel leftPane;
//	private Container container;
//
//	JSplitPane entireView = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
//
//	JTabbedPane tabbedPane;
//
//	private JLabel clusterModeLabel;
//	private JLabel clusterNumberLabel;
//	private JLabel imageLabel;
//	private JLabel timeLabel;
//	private JLabel algorithmLabel;
//
//	private JComboBox<String> clusterModeList;
//	private JComboBox<Integer> clusterNumberList;
//	private JComboBox<String> timeComboBox;
//	private JComboBox<String> algorithmComboBox;
//
//	private JButton chartButton;
//	private JButton startButton;
//	private JButton clusterButton;
//
//	private NiceIntegerSlider integerSlider;
//
//	private ChartPanel chartPanelTime;
//	private ChartPanel chartPanelCount;
//	private ChartDialog chartDialog;
//
//	private ImageIcon icon;
//
//	public Map<Integer, String> clusterNameMap;
//	public Map<Integer, Integer> indexToClusterMap;
//
//	double[] sqErrorsTime;
//	double[] sqErrorsCount;
//	int numberOfTabs = 1;
//	boolean countFlag = false;
//	boolean timeFlag = false;
//	boolean publishNumberedFlag = false;
//
//	ElbowMethod elbow = new ElbowMethod();
//	HeatChart heatmap;
//
//	@Plugin(name = "Show Cluster Visualization", returnLabels = {"Cluster Visualization"},
//			returnTypes = {JComponent.class}, parameterLabels = {"TimeAndCountModel"},
//			userAccessible = true)
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "S. Dündar", email = "s.dundar@student.tue.nl")
//	@Visualizer(name = "Clustering Visualization")
//	public JComponent visualize(UIPluginContext context, TimeAndCountModel model) throws Exception {
//		globalContext = context;
//		globalModel = model;
//		globalParameter = globalModel.getParameterValues();
//
//		slickerFactory = SlickerFactory.instance();
//		slickerDecorator = SlickerDecorator.instance();
//
//		// Return the results in headpanel
//		headPanel = new JPanel(new BorderLayout());
//		entireView.setOpaque(false);
//		entireView.setOneTouchExpandable(true);
//
//		// Create the JTabbedPane and set it as the right component of the entire splitpane
//		tabbedPane = new JTabbedPane();
//		entireView.setRightComponent(tabbedPane);
//
//		//		// First of all compute the squared errors for the elbow graph
//		//		sqErrorsTime = elbow.run(globalModel.getDataSet());
//		//		chartPanelTime = createElbowChartTime(sqErrorsTime);
//
//		// Left panel: Parameters selection and calculate button
//		leftPane = new JPanel();
//		leftPane.setPreferredSize(new Dimension(250, 80));
//		leftPane.setBackground(Color.DARK_GRAY);
//		leftPane.setForeground(Color.WHITE);
//		leftPane.setLayout(new BoxLayout(leftPane, BoxLayout.PAGE_AXIS));
//		leftPane.setBorder(new EmptyBorder(15, 5, 5, 15));
//
//		// Clustering Mode Information
//		clusterModeLabel = slickerFactory.createLabel("Select Clustering Mode");
//		clusterModeLabel.setForeground(leftPane.getForeground());
//		leftPane.add(clusterModeLabel);
//
//		// Clustering Mode ComboBox Information
//		clusterModeList = slickerFactory.createComboBox(new String[] {"Clustering Sessions based on Time", "Clustering Sessions based on Frequency"});
//		clusterModeList.addItemListener(new ItemListener() {
//			public void itemStateChanged(ItemEvent evt) {
//				JComboBox comboBox = (JComboBox) evt.getSource();
//				Object item = evt.getItem();
//				if (evt.getStateChange() == ItemEvent.SELECTED) {
//					try {
//						if (clusterModeList.getSelectedItem().equals("Clustering Sessions based on Time")) {
//							if (timeFlag = false) {
//								chartPanelTime = createElbowChartTime(sqErrorsTime);
//							}
//						} else if (clusterModeList.getSelectedItem().equals("Clustering Sessions based on Frequency")) {
//							if (countFlag == false) {
//								try {
//									chartPanelCount = createElbowChartCount(sqErrorsCount);
//								} catch (Exception e) {}
//							}
//						}
//					} catch (Exception e) {}
//				}
//			}
//		});
//		leftPane.add(clusterModeList);
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 15)));
//
//		algorithmLabel = slickerFactory.createLabel("Select Clustering Algorithm");
//		algorithmLabel.setForeground(leftPane.getForeground());
//		leftPane.add(algorithmLabel);
//		algorithmComboBox = new JComboBox();
//		slickerDecorator.decorate(algorithmComboBox);
//		algorithmComboBox.setModel(new DefaultComboBoxModel<>(new String[] {"K-Means", "DBSCAN"}));
//		leftPane.add(algorithmComboBox);
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 15)));
//
//		timeLabel = slickerFactory.createLabel("Select Parameter Values");
//		timeLabel.setForeground(leftPane.getForeground());
//		leftPane.add(timeLabel);
//
//		integerSlider = slickerFactory.createNiceIntegerSlider("", 1, 60, 15, Orientation.HORIZONTAL);	
//		integerSlider.setForeground(leftPane.getForeground());
//		timeComboBox = new JComboBox();
//		slickerDecorator.decorate(timeComboBox);
//		timeComboBox.setModel(new DefaultComboBoxModel<>(new String[] {"Minutes", "Hours", "Days", "Weeks", "Months"}));
//
//		Container c = new Container();
//		c.setLayout(new BoxLayout(c, BoxLayout.LINE_AXIS));
//		c.add(integerSlider);
//		c.add(timeComboBox);
//		leftPane.add(c);
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 15)));
//
//		clusterButton = slickerFactory.createButton("Start Clustering");
//		clusterButton.addActionListener(new ActionListener() {
//			@Override
//			public void actionPerformed(ActionEvent e) {
//				String timeParameter = (String) timeComboBox.getSelectedItem();
//				globalParameter.setComboBoxItem(timeParameter);
//
//				if (timeParameter.equals("Minutes")) {
//					globalParameter.setMineMode(globalParameter.MINUTES);
//				} else if (timeParameter.equals("Hours")) {
//					globalParameter.setMineMode(globalParameter.HOURS);
//				} else if (timeParameter.equals("Days")) {
//					globalParameter.setMineMode(globalParameter.DAYS);
//				} else if (timeParameter.equals("Weeks")) {
//					globalParameter.setMineMode(globalParameter.WEEKS);
//				} else if (timeParameter.equals("Months")) {
//					globalParameter.setMineMode(globalParameter.MONTHS);
//				}
//
//				int integerSliderValue = integerSlider.getValue();
//				globalParameter.setTextFieldValue(integerSliderValue);
//
//				if (((String) clusterModeList.getSelectedItem()).equals("Clustering Sessions based on Time")) {
//					TimeAndCountPlugin3 plugin = new TimeAndCountPlugin3();
//					plugin.setMode((String) clusterModeList.getSelectedItem());
//					final TimeAndCountModel modelTime = plugin.mineParameters(globalContext, globalModel.getEventLog(), globalParameter);
//
//					// First of all compute the squared errors for the elbow graph
//					try {
//						sqErrorsTime = elbow.run(modelTime.getDataSet());
//						chartPanelTime = createElbowChartTime(sqErrorsTime);
//					} catch (Exception e1) {}
//
//					timeFlag = true;
//				} else if (((String) clusterModeList.getSelectedItem()).equals("Clustering Sessions based on Frequency")) {
//					TimeAndCountPlugin3 plugin = new TimeAndCountPlugin3();
//					plugin.setMode((String) clusterModeList.getSelectedItem());
//					final TimeAndCountModel modelCount = plugin.mineParameters(globalContext, globalModel.getEventLog(), globalParameter);
//
//					try {
//						sqErrorsCount = elbow.run(modelCount.getDataSet());
//						chartPanelCount = createElbowChartCount(sqErrorsCount);
//					} catch (Exception e2) {}
//
//					countFlag = true;
//				}
//
//
//			}
//		});
//		leftPane.add(clusterButton);
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 30)));
//
//		container = new Container();
//		container.setLayout(new BoxLayout(container, BoxLayout.LINE_AXIS));
//
//		// Number of Cluster Selection Information
//		clusterNumberLabel = slickerFactory.createLabel("Select number of clusters");
//		clusterNumberLabel.setForeground(leftPane.getForeground());
//		leftPane.add(clusterNumberLabel);
//
//		Integer[] clusterNumbs = new Integer[20];
//		for (int i = 0; i < clusterNumbs.length; i++) {
//			clusterNumbs[i] = i + 1;
//		}
//		clusterNumberList = slickerFactory.createComboBox(clusterNumbs);
//		clusterNumberList.setPreferredSize(new Dimension(0, 5));
//		slickerDecorator.decorate(clusterNumberList);
//		container.add(clusterNumberList);
//
//		chartButton = slickerFactory.createButton("Elbow Graph");
//		chartButton.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent evt) {
//				try {
//					if (clusterModeList.getSelectedItem().equals("Clustering Sessions based on Time")) {
//						chartDialog = new ChartDialog(chartPanelTime);
//					} else if (clusterModeList.getSelectedItem().equals("Clustering Sessions based on Frequency")) {
//						chartDialog = new ChartDialog(chartPanelCount);
//					}
//					if (chartDialog != null) {
//						chartDialog.setAlwaysOnTop(true);
//						chartDialog.setLocation(MouseInfo.getPointerInfo().getLocation());
//						chartDialog.setVisible(true);
//					}
//				} catch (Exception e) {}
//			}
//		});
//		container.add(chartButton);
//		leftPane.add(container);
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 15)));
//
//		// The Start Clustering Button
//		startButton = slickerFactory.createButton("Generate Heatmap");
//		startButton.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				if (algorithmComboBox.getSelectedItem().equals("K-Means")) {
//					addATabKmeans();
//				} else if (algorithmComboBox.getSelectedItem().equals("DBSCAN")) {
//					addATabDBSCAN();
//				}
//			}
//		});
//		leftPane.add(startButton);
//
//		// Wrap everything together and return
//		entireView.setLeftComponent(leftPane);
//		headPanel.add(entireView, BorderLayout.CENTER);
//
//		return headPanel;
//	}
//
//	private ChartPanel createElbowChartTime(double[] sqErrorsTime) {
//		XYDataset dataset = createDatasetTime();
//
//		JFreeChart chart = ChartFactory.createXYLineChart("Elbow Method Time Based (" + integerSlider.getValue() + " " + timeComboBox.getSelectedItem().toString() + ")" , 
//				"Number of Clusters", "Within Sum of Squared Errors", 
//				dataset,
//				PlotOrientation.VERTICAL, true, true, false);
//
//		// Customize the chart
//		XYPlot plot = chart.getXYPlot();
//		XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
//
//		renderer.setSeriesPaint(0, Color.RED);
//		renderer.setSeriesPaint(1, Color.BLACK);
//		renderer.setSeriesStroke(0, new BasicStroke(3.0f));
//
//		plot.setRenderer(renderer);
//		plot.setBackgroundPaint(Color.DARK_GRAY);
//		plot.setRangeGridlinesVisible(true);
//		plot.setRangeGridlinePaint(Color.BLACK);
//		plot.setDomainGridlinesVisible(true);
//		plot.setDomainGridlinePaint(Color.BLACK);
//
//		// Create the ChartPanel
//		ChartPanel panel = new ChartPanel(chart);
//
//
//		return panel;
//	}
//
//	private XYDataset createDatasetTime() {
//		XYSeriesCollection dataset = new XYSeriesCollection();
//		XYSeries series = new XYSeries("Within Sum of Squared Errors");
//		for (int i = 0; i < sqErrorsTime.length; i++) {
//			series.add(i + 1, sqErrorsTime[i]);
//		}
//
//		XYSeries series2 = new XYSeries("Straight Line");
//		series2.add(1, sqErrorsTime[0]);
//		series2.add(20, sqErrorsTime[19]);
//
//		// Add series to dataset
//		dataset.addSeries(series);
//		dataset.addSeries(series2);
//
//		return dataset;
//	}
//
//	private ChartPanel createElbowChartCount(double[] sqErrorsCount) {
//		XYDataset dataset = createDatasetCount();
//
//		JFreeChart chart = ChartFactory.createXYLineChart("The Elbow Method Frequency Based (" + integerSlider.getValue() + " " + timeComboBox.getSelectedItem().toString() + ")", 
//				"Number of Clusters", "Within Sum of Squared Errors", 
//				dataset,
//				PlotOrientation.VERTICAL, true, true, false);
//
//		// Customize the chart
//		XYPlot plot = chart.getXYPlot();
//		XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
//
//		renderer.setSeriesPaint(0, Color.RED);
//		renderer.setSeriesPaint(1, Color.BLACK);
//		renderer.setSeriesStroke(0, new BasicStroke(3.0f));
//
//		plot.setRenderer(renderer);
//		plot.setBackgroundPaint(Color.DARK_GRAY);
//		plot.setRangeGridlinesVisible(true);
//		plot.setRangeGridlinePaint(Color.BLACK);
//		plot.setDomainGridlinesVisible(true);
//		plot.setDomainGridlinePaint(Color.BLACK);
//
//		// Create the ChartPanel
//		ChartPanel panel = new ChartPanel(chart);
//
//		return panel;
//	}
//
//	private XYDataset createDatasetCount() {
//		XYSeriesCollection dataset = new XYSeriesCollection();
//		XYSeries series = new XYSeries("Within Sum of Squared Errors");
//		for (int i = 0; i < sqErrorsCount.length; i++) {
//			series.add(i + 1, sqErrorsCount[i]);
//		}
//
//		XYSeries series2 = new XYSeries("Straight Line");
//		series2.add(1, sqErrorsCount[0]);
//		series2.add(20, sqErrorsCount[19]);
//
//		// Add series to dataset
//		dataset.addSeries(series);
//		dataset.addSeries(series2);
//
//		return dataset;
//	}
//
//	private HeatChart createHeatmapKmeans(KMeans kmeans, String colourScale) {
//		heatmap = new HeatChart(kmeans.getMatrix());
//		heatmap.setTitle("Clustering Results K-Means");
//		heatmap.setXValues(kmeans.getClusters().toArray());
//		heatmap.setXAxisLabel("Cluster");
//		heatmap.setYValues(kmeans.getAttributeNames().toArray());
//		heatmap.setYAxisLabel("Event");
//
//		if (colourScale.equals("Logarithmic")) {
//			heatmap.setColourScale(heatmap.SCALE_LOGARITHMIC);
//		} else if (colourScale.equals("Linear")) {
//			heatmap.setColourScale(heatmap.SCALE_LINEAR);
//		} else if (colourScale.equals("Exponential")) {
//			heatmap.setColourScale(heatmap.SCALE_EXPONENTIAL);
//		}
//
//		heatmap.setHighValueColour(Color.RED);
//		return heatmap;
//	}
//
//	private HeatChart createHeatMapDbscan(Dbscan dbscan, String colourScale) {
//		heatmap = new HeatChart(dbscan.getMatrix());
//		heatmap.setTitle("Clustering Results DBSCAN");
//		heatmap.setXValues(dbscan.getClusters().toArray());
//		heatmap.setXAxisLabel("Cluster");
//		heatmap.setYValues(dbscan.getAttributeNames().toArray());
//		heatmap.setYAxisLabel("Event");
//
//		if (colourScale.equals("Logarithmic")) {
//			heatmap.setColourScale(heatmap.SCALE_LOGARITHMIC);
//		} else if (colourScale.equals("Linear")) {
//			heatmap.setColourScale(heatmap.SCALE_LINEAR);
//		} else if (colourScale.equals("Exponential")) {
//			heatmap.setColourScale(heatmap.SCALE_EXPONENTIAL);
//		}
//
//		heatmap.setHighValueColour(Color.RED);
//		return heatmap;
//	}
//
//	public void addATabKmeans() {
//
//		Executor exec = globalContext.getExecutor();
//		Runnable task = new Runnable() {
//			public void run() {
//				startButton.setText("Generating Heatmap...");
//
//				final Parameters parameters = globalModel.getParameterValues();
//				System.out.println(parameters.getTextFieldValue());
//				TimeAndCountPlugin3 plugin = new TimeAndCountPlugin3();
//				plugin.setMode((String) clusterModeList.getSelectedItem());
//				final TimeAndCountModel model = plugin.mineParameters(globalContext, globalModel.getEventLog(), parameters);
//				CreateAbstractedLog createAbstractLog = new CreateAbstractedLog();
//
//				KMeans kmeans = new KMeans();
//
//				int clusterNumber  = (int) clusterNumberList.getSelectedItem();
//				kmeans.setNumberOfClusters(clusterNumber);
//				try {
//					kmeans.buildIt(model.getDataSet());
//				} catch (Exception e1) {
//				}
//
//				// ColourScale Selection ComboBox
//				final JComboBox<String> colourScaleList = slickerFactory.createComboBox(new String[] {"Logarithmic", "Linear", "Exponential"});
//				slickerDecorator.decorate(colourScaleList);
//
//				final NiceDoubleSlider thresholdSliderNice = slickerFactory.createNiceDoubleSlider("", kmeans.getMinValue(), kmeans.getMaxValue(), kmeans.getMinValue(), Orientation.HORIZONTAL);
//				final JButton updateButton = slickerFactory.createButton("Update Heatmap");
//				final JButton exportButton = slickerFactory.createButton("Generate Abstracted Log");
//				final JCheckBox checkbox = slickerFactory.createCheckBox("Enable Numbering", false);
//
//				JPanel rightTabPane = new JPanel();
//				rightTabPane.setPreferredSize(new Dimension(250, 80));
//				rightTabPane.setLayout(new BoxLayout(rightTabPane, BoxLayout.PAGE_AXIS));
//
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 50)));
//				rightTabPane.add(slickerFactory.createLabel("Clustering Mode: " + clusterModeList.getSelectedItem()));
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//				rightTabPane.add(slickerFactory.createLabel("Selected Number of Clusters: " + clusterNumberList.getSelectedItem()));
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 50)));
//				rightTabPane.add(slickerFactory.createLabel("Choose Heatmap Colouring Scale"));
//				rightTabPane.add(colourScaleList);
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//				rightTabPane.add(slickerFactory.createLabel("Select Threshold Value"));
//				rightTabPane.add(thresholdSliderNice);
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//				rightTabPane.add(updateButton);
//				rightTabPane.add(Box.createRigidArea(new Dimension(0,100)));
//
//				String cs = (String) colourScaleList.getSelectedItem();
//				heatmap = createHeatmapKmeans(kmeans, cs);
//				icon = new ImageIcon(heatmap.getChartImage());
//				imageLabel = new JLabel(icon);
//
//				JPanel clusterPanel = new JPanel();
//				clusterPanel.setLayout(new BoxLayout(clusterPanel, BoxLayout.LINE_AXIS));
//				JPanel clusterNamesPanel = new JPanel();
//				clusterNamesPanel.setLayout(new GridLayout(kmeans.getNumberOfClusters(), 2));
//				List<JTextField> textFields = new ArrayList<JTextField>();
//				for (int i = 0; i < kmeans.getNumberOfClusters(); i++) {
//					JLabel label = new JLabel("Cluster " + i + ": ");
//					JTextField textField = new JTextField(20);
//					label.setLabelFor(textField);
//					clusterNamesPanel.add(label);
//					clusterNamesPanel.add(textField);
//					textFields.add(textField);
//				}
//				clusterPanel.add(clusterNamesPanel);
//
//				// Insert margin
//				clusterPanel.add(Box.createRigidArea(new Dimension(0, 15)));
//
//				JPanel checkboxExportButtonPanel = new JPanel();
//				Container c = new Container();
//				c.setLayout(new BoxLayout(c, BoxLayout.PAGE_AXIS));
//				c.add(checkbox);
//				c.add(exportButton);
//				checkboxExportButtonPanel.add(c);
//				clusterPanel.add(checkboxExportButtonPanel);
//
//				// Pre-fill the textfields with the name of the events with the highest value in each of the clusters
//				String[] maxEventNames = new String[kmeans.getNumberOfClusters()];
//				for (Integer cluster : kmeans.getClustertoAttributeValueMap().keySet()) {
//					Map<String, Double> map = kmeans.getClustertoAttributeValueMap().get(cluster);
//					double maxValueInMap = (Collections.max(map.values()));
//					for (Entry<String, Double> entry : map.entrySet()) {
//						if (entry.getValue() == maxValueInMap) {
//							maxEventNames[cluster] = entry.getKey();
//						}
//					}
//				}               
//				for (int i = 0; i < textFields.size(); i++) {
//					textFields.get(i).setText(maxEventNames[i]);
//				}
//
//				JScrollPane heatmapScrollPane = new JScrollPane(imageLabel);
//				JSplitPane resultSplitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, heatmapScrollPane, clusterPanel);
//				resultSplitPane.setResizeWeight(0.85);
//				JSplitPane tabViewPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, resultSplitPane, rightTabPane);
//				tabViewPane.setOpaque(false);
//				tabViewPane.setOneTouchExpandable(true);
//				tabViewPane.setResizeWeight(1);
//
//				if (clusterModeList.getSelectedItem().equals("Clustering Sessions based on Frequency")) {
//					tabbedPane.add(kmeans.getNumberOfClusters() + " clusters (count based)", tabViewPane);
//				} else {
//					tabbedPane.add(kmeans.getNumberOfClusters() + " clusters (time based)", tabViewPane);
//				}
//				tabbedPane.setTabComponentAt(numberOfTabs - 1, new ButtonTabComponent(tabbedPane));
//				tabbedPane.setSelectedIndex(numberOfTabs - 1);
//				numberOfTabs++;
//				startButton.setText("Generate Heatmap");
//
//				updateButton.addActionListener(new ActionListener() {
//					public void actionPerformed(ActionEvent evt) {
//						try {
//							kmeans.setActualThresholdValue(thresholdSliderNice.getValue());
//							kmeans.runFiltered(model.getDataSet());
//						} catch (Exception e) {
//						}
//						String cs = (String) colourScaleList.getSelectedItem();
//						heatmap = createHeatmapKmeans(kmeans, cs);
//						icon = new ImageIcon(heatmap.getChartImage());
//						imageLabel = new JLabel(icon);
//						JScrollPane heatmapScrollPane = new JScrollPane(imageLabel);
//						resultSplitPane.setLeftComponent(heatmapScrollPane);
//					}
//				});
//
//				exportButton.addActionListener(new ActionListener() {
//					public void actionPerformed(ActionEvent e) {
//						exportButton.setText("Creating Abstracted Log...");
//
//						clusterNameMap = new TreeMap<Integer, String>();
//						for (int i = 0; i < textFields.size(); i++) {
//							clusterNameMap.put(i, textFields.get(i).getText());
//						}
//						globalModel.setClusterNameMap(clusterNameMap);
//
//						int[] assignments = kmeans.getClusterAssignments();
//						indexToClusterMap = new TreeMap<Integer, Integer>();
//						for (int i = 0; i < assignments.length; i++) {
//							indexToClusterMap.put(i, assignments[i]);
//						}
//						globalModel.setIndexToClusterMap(indexToClusterMap);
//
//						if (countFlag == true) {
//							if (publishNumberedFlag == true) {
//								if (parameters.getMineMode() == parameters.MIN15) {
//									XLog abstractLog = createAbstractLog.mineAbstract15Min(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log 15 Minutes Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAILY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDaily(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Daily Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeekly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Weekly Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonthly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Monthly Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MINUTES) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMinutes(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Minutes Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.HOURS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogHours(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Hours Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAYS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDays(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Days Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeeks(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Weeks Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonths(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Months Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								}
//							} else {
//								if (parameters.getMineMode() == parameters.MIN15) {
//									XLog abstractLog = createAbstractLog.mineAbstract15Min(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log 15 Minutes Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAILY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDaily(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Daily Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeekly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Weekly Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonthly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Monthly Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MINUTES) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMinutes(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Minutes Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.HOURS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogHours(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Hours Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAYS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDays(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Days Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeeks(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Weeks Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonths(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Months Count (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								}
//							}
//						} else {
//							if (publishNumberedFlag == true) {
//								if (parameters.getMineMode() == parameters.MIN15) {
//									XLog abstractLog = createAbstractLog.mineAbstract15Min(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log 15 Minutes (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAILY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDaily(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Daily (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeekly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Weekly (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonthly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Monthly (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MINUTES) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMinutes(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Minutes (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.HOURS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogHours(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Hours (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAYS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDays(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Days (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeeks(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Weeks (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonths(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Numbered Abstract Log Months (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								}
//							} else {
//								if (parameters.getMineMode() == parameters.MIN15) {
//									XLog abstractLog = createAbstractLog.mineAbstract15Min(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log 15 Minutes (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAILY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDaily(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Daily (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeekly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Weekly (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHLY) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonthly(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Monthly (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MINUTES) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMinutes(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Minutes (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.HOURS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogHours(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Hours (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.DAYS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogDays(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Days (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.WEEKS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogWeeks(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Days (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								} else if (parameters.getMineMode() == parameters.MONTHS) {
//									XLog abstractLog = createAbstractLog.mineAbstractLogMonths(globalModel.getEventLog(), globalModel);
//									publish(globalContext, "Abstract Log Months (" + kmeans.getNumberOfClusters() + " clusters)", abstractLog, XLog.class, true);
//								}
//							}
//						}
//
//						exportButton.setText("Abstracted Log Created");
//						try {
//							Thread.currentThread().sleep(2000);
//						} catch (InterruptedException e1) {
//						}      
//
//						Timer timer2 = new Timer(2000, new ActionListener() {
//							public void actionPerformed(ActionEvent e) {
//								exportButton.setText("Generate Abstracted Log");
//							}
//						});
//						timer2.start();
//
//					}
//				});
//
//				checkbox.addActionListener(new ActionListener() {
//					public void actionPerformed(ActionEvent evt) {
//						JCheckBox cbLog = (JCheckBox) evt.getSource();
//						if (cbLog.isSelected()) {
//							createAbstractLog.setWithNumbers(true);
//							publishNumberedFlag = true;
//						} else {
//							createAbstractLog.setWithNumbers(false);
//							publishNumberedFlag = false;
//						}
//					}       
//				});
//
//
//				startButton.setText("Generate Heatmap");
//
//
//			}
//		};
//		exec.execute(task);
//
//	} // End of addATabKmeans method
//
//	public void addATabDBSCAN() {
//		Executor exec = globalContext.getExecutor();
//		Runnable task = new Runnable() {
//			public void run() {
//				startButton.setText("Generating Heatmap (DBSCAN)...");
//
//				final Parameters parameters = globalModel.getParameterValues();
//				TimeAndCountPlugin3 plugin = new TimeAndCountPlugin3();
//				plugin.setMode((String) clusterModeList.getSelectedItem());
//				final TimeAndCountModel model = plugin.mineParameters(globalContext, globalModel.getEventLog(), parameters);
//				CreateAbstractedLog createAbstractLog = new CreateAbstractedLog();
//
//				Dbscan dbscan = new Dbscan();
//
//				try {
//					dbscan.buildIt(model.getDataSet());
//				} catch (Exception e) {}
//
//				// ColourScale Selection ComboBox
//				final JComboBox<String> colourScaleList = slickerFactory.createComboBox(new String[] {"Logarithmic", "Linear", "Exponential"});
//				slickerDecorator.decorate(colourScaleList);
//
//				final NiceDoubleSlider thresholdSliderNice = slickerFactory.createNiceDoubleSlider("", dbscan.getMinValue(), dbscan.getMaxValue(), dbscan.getMinValue(), Orientation.HORIZONTAL);
//				final JButton updateButton = slickerFactory.createButton("Update Heatmap");
//				final JButton exportButton = slickerFactory.createButton("Generate Abstracted Log");
//				final JCheckBox checkbox = slickerFactory.createCheckBox("Enable Numbering", false);
//
//				JPanel rightTabPane = new JPanel();
//				rightTabPane.setPreferredSize(new Dimension(250, 80));
//				rightTabPane.setLayout(new BoxLayout(rightTabPane, BoxLayout.PAGE_AXIS));
//
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 50)));
//				rightTabPane.add(slickerFactory.createLabel("Clustering Mode: " + clusterModeList.getSelectedItem()));
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//				rightTabPane.add(slickerFactory.createLabel("Selected Number of Clusters: " + clusterNumberList.getSelectedItem()));
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 50)));
//				rightTabPane.add(slickerFactory.createLabel("Choose Heatmap Colouring Scale"));
//				rightTabPane.add(colourScaleList);
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//				rightTabPane.add(slickerFactory.createLabel("Select Threshold Value"));
//				rightTabPane.add(thresholdSliderNice);
//				rightTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//				rightTabPane.add(updateButton);
//				rightTabPane.add(Box.createRigidArea(new Dimension(0,100)));
//
//				String cs = (String) colourScaleList.getSelectedItem();
//				heatmap = createHeatMapDbscan(dbscan, cs);
//				icon = new ImageIcon(heatmap.getChartImage());
//				imageLabel = new JLabel(icon);
//
//				JPanel clusterPanel = new JPanel();
//				clusterPanel.setLayout(new BoxLayout(clusterPanel, BoxLayout.LINE_AXIS));
//				JPanel clusterNamesPanel = new JPanel();
//				clusterNamesPanel.setLayout(new GridLayout(dbscan.getNumberOfClusters(), 4));
//				List<JTextField> textFields = new ArrayList<JTextField>();
//				for (int i = 0; i < dbscan.getNumberOfClusters(); i++) {
//					JLabel label = new JLabel("Cluster " + i + ": ");
//					JTextField textField = new JTextField(20);
//					label.setLabelFor(textField);
//					clusterNamesPanel.add(label);
//					clusterNamesPanel.add(textField);
//					textFields.add(textField);
//				}
//				clusterPanel.add(clusterNamesPanel);
//
//				// Insert margin
//				clusterPanel.add(Box.createRigidArea(new Dimension(0, 15)));
//
//				JPanel checkboxExportButtonPanel = new JPanel();
//				Container c = new Container();
//				c.setLayout(new BoxLayout(c, BoxLayout.PAGE_AXIS));
//				c.add(checkbox);
//				c.add(exportButton);
//				checkboxExportButtonPanel.add(c);
//				clusterPanel.add(checkboxExportButtonPanel);
//
//				// Pre-fill the textfields with the name of the events with the highest value in each of the clusters
//				String[] maxEventNames = new String[dbscan.getNumberOfClusters()];
//				for (Integer cluster : dbscan.getClusterToAttributeValueMap().keySet()) {
//					Map<String, Double> map = dbscan.getClusterToAttributeValueMap().get(cluster);
//					double maxValueInMap = (Collections.max(map.values()));
//					for (Entry<String, Double> entry : map.entrySet()) {
//						if (entry.getValue() == maxValueInMap) {
//							maxEventNames[cluster] = entry.getKey();
//						}
//					}
//				}
//				for (int i = 0; i < textFields.size(); i++) {
//					textFields.get(i).setText(maxEventNames[i]);
//				}
//
//				JScrollPane heatmapScrollPane = new JScrollPane(imageLabel);
//				JSplitPane resultSplitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, heatmapScrollPane, clusterPanel);
//				resultSplitPane.setResizeWeight(0.85);
//				JSplitPane tabViewPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, resultSplitPane, rightTabPane);
//				tabViewPane.setOpaque(false);
//				tabViewPane.setOneTouchExpandable(true);
//				tabViewPane.setResizeWeight(1);
//
//				if (clusterModeList.getSelectedItem().equals("Clustering Sessions based on Frequency")) {
//					tabbedPane.add(dbscan.getNumberOfClusters() + " clusters (count based)", tabViewPane);
//				} else {
//					tabbedPane.add(dbscan.getNumberOfClusters() + " clusters (time based)", tabViewPane);
//				}
//				tabbedPane.setTabComponentAt(numberOfTabs - 1, new ButtonTabComponent(tabbedPane));
//				tabbedPane.setSelectedIndex(numberOfTabs - 1);
//				numberOfTabs++;
//				startButton.setText("Generate Heatmap");
//
//				updateButton.addActionListener(new ActionListener() {
//					public void actionPerformed(ActionEvent evt) {
//						try {
//							dbscan.setActualThresholdValue(thresholdSliderNice.getValue());
//							dbscan.runFiltered(model.getDataSet());
//						} catch (Exception e) {
//						}
//						String cs = (String) colourScaleList.getSelectedItem();
//						heatmap = createHeatMapDbscan(dbscan, cs);
//						icon = new ImageIcon(heatmap.getChartImage());
//						imageLabel = new JLabel(icon);
//						JScrollPane heatmapScrollPane = new JScrollPane(imageLabel);
//						resultSplitPane.setLeftComponent(heatmapScrollPane);
//					}
//				});
//
//				// EXPORTBUTTON ACTIONLISTENER NOT IMPLEMENTED YET FOR DBSCAN!!!
//
//				checkbox.addActionListener(new ActionListener() {
//					public void actionPerformed(ActionEvent evt) {
//						JCheckBox cbLog = (JCheckBox) evt.getSource();
//						if (cbLog.isSelected()) {
//							createAbstractLog.setWithNumbers(true);
//							publishNumberedFlag = true;
//						} else {
//							createAbstractLog.setWithNumbers(false);
//							publishNumberedFlag = false;
//						}
//					}       
//				});
//
//				startButton.setText("Generate Heatmap");
//			}
//		};
//		exec.execute(task);
//	} // End of addATabDBSCAN method
//
//	private static <T> void publish(final PluginContext context, final String name, final T object,
//			final Class<? super T> clazz, final boolean favorite) {
//		final ProvidedObjectID id = context.getProvidedObjectManager().createProvidedObject(name, object, clazz, context);
//
//		if (context instanceof UIPluginContext) {
//			final GlobalContext gcontext = ((UIPluginContext) context).getGlobalContext();
//			if (gcontext instanceof UIContext) {
//				final UIContext uicontext = (UIContext) gcontext;
//				final ResourceType resType = uicontext.getResourceManager().getResourceTypeFor(clazz);
//				if (resType != null) {
//					ProMTask task = null;
//					try {
//						final Field taskField = context.getClass().getDeclaredField("task");
//						taskField.setAccessible(true);
//						task = (ProMTask) taskField.get(context);
//					} catch (final Exception _) {
//						// Guess it wasn't meant to be, then...
//					}
//					final List<Collection<ProMPOResource>> lst = Collections.emptyList();
//					ProMPOResource res = new ProMPOResource(uicontext, task == null ? null : task.getAction(), resType, 
//							id, lst);
//					res = uicontext.getResourceManager().addResource(id, res);
//				}
//			}
//		}
//		if (favorite) {
//			ProvidedObjectHelper.setFavorite(context, object);
//		}
//	} // End of publish method
//
//
//
//} // End of Class
